var express = require('express');
var path = require('path');
var request = require('request');

// UPDATE THESE TO YOUR DETAILS!
var client = {
	id: 'YOUR CLIENT ID',
	secret: 'YOUR CLIENT SECRET',
	deployment: 'THE END USERS DEPLOYMENT NAME', // e.q "me" for "me.accelo.com"
};
	
var app = express();

// serve static files
app.use(express.static('static'));

// home page with "connect" button
app.get('/', function(req, res) {
	res.sendFile('index.html', { root: path.join(__dirname) });
});

// direct user here when they click on "connect" button
app.get('/connect', function(req, res) {
	var url = 'https://' + client.deployment + '.api.accelo.com/oauth2/v0/authorize?';
	url += 'response_type=code&';
	url += 'client_id=' + encodeURIComponent(client.id);
	
	console.log('Redirecting user to', url);
	res.redirect(url);
});

// catch oauth2 callback here
app.get('/oauth2', function(req, res) {
	console.log('Got code', req.query.code);
	
	request({
		method: 'post',
		url: 'https://' + client.deployment + '.api.accelo.com/oauth2/v0/token',
		headers: {
			'Content-Type': 'application/json',
			'Authorization': 'Basic ' + new Buffer(client.id + ':' + client.secret).toString('base64'),
		},
		json: {
			grant_type: 'authorization_code',
			code: req.query.code
		}
	}, function (error, response, body) {
		console.log('Got token', response);
		res.send(response);
	});
});

// Start server
var server = app.listen(8081, function () {
	var port = server.address().port
	console.log("Sample web app listening at http://localhost:%s", port);
	console.log("You web application should redirect to http://localhost:%s/oauth2", port)
});
